#include <stdio.h>
#include <stdlib.h>
#include <string.h>


typedef struct {
	int x, y;
} POINT;

POINT *v0;

int comparition ( const void *a, const void *b )
{
	POINT *v1, *v2;
	int n;

	v1 = (POINT *)a;
	v2 = (POINT *)b;
	
	n = (v1->x - v0->x)*(v2->y - v0->y) -
	        (v1->y - v0->y)*(v2->x - v0->x);

	if ( n < 0 )  return 1;
	else
		return -1;
}
 

void swap_v( POINT *a, POINT *b)
{
	int tmp;

	tmp = a->x; a->x = b->x; b->x = tmp;
	tmp = a->y; a->y = b->y; b->y = tmp;
}

int read_file( char *name )
{
	FILE *fp;
	POINT *data;
	char line[64], *pchar;
	int i, n, x, y;
	int min;

	if( (fp=fopen( name, "r"))==NULL ) {
		fprintf( stderr, "ERROR: opening %s file\n", name );
		return(1);	
	}
	for ( i=0;; ) {
		if( fgets( line, 64, fp ) == NULL ) break;

		pchar=line; 
		while( *pchar==' ' || *pchar=='\t' ) pchar++;
		if ( *pchar == '\n' || *pchar == '#' ) continue;

		if ( sscanf( pchar, "%d %d", &x, &y ) != 2 ) {
			fprintf( stderr, "ERROR: readind %s file\n", name );
			fclose ( fp );
			return (1);
		} 
		i++;
	}
	n = i;

	if( (data=(POINT *)malloc( n*sizeof(POINT)))==NULL ) {
		fprintf( stderr, "ERROR: allocating memory\n" );
		fclose ( fp );
		return (1);
	}

	fseek( fp, 0, SEEK_SET );
	for ( i=0;; ) {
		if( fgets( line, 64, fp ) == NULL ) break;

		pchar=line; 
		while( *pchar==' ' || *pchar=='\t' ) pchar++;
		if ( *pchar == '\n' || *pchar == '#' ) continue;

		if ( sscanf( pchar, "%d %d", &x, &y ) != 2 ) {
			fprintf( stderr, "ERROR: readind %s file\n", name );
			fclose ( fp );
			return (1);
		} 
		data[i].x = x;
		data[i].y = y;
		i++;
	}
	fclose( fp );

	/** find the point with minimum y-coordinate **/
	min = 0;
	for( i=1; i<n; i++ ) 
		if ( data[i].y < data[min].y ) min = i;

	/** among all such points, find the one with minimum
	    x-coordinate  **/
	for( i=0; i<n; i++ ) 
		if ( (data[i].y == data[min].y) && (data[i].x < data[min].x) )
			min = i; 

	v0 = &data[0];	
	swap_v( v0, &data[min] );

	qsort( (void *)&data[1], n-1, sizeof(POINT), comparition );

	printf( "# i  x  y\n" );
	for ( i=0; i<n; i++ ) 
		printf ( "%d %d\n", data[i].x, data[i].y );

	free( data );
	return 0;
}

int main( int argc, char *argv[] )
{
	char namein[64];

	if ( argc == 2 ) {
		strncpy( namein, argv[1], 64 );
		if( read_file( namein ) ) {
			fprintf( stderr, "ERROR!\n" );
			exit(1);
		}
	}
	else {
		fprintf( stderr, "Args: file_name\n" );
		exit(1);
	}
	return 0;
}

